module Omniauth
  module Edumall
    module User
      extend self
      EDUMALL_SSO_URL = 'https://accounts.edumall.vn'
      def user_logout?(cookies)
        edumall_access_token = cookies[:edumall_access_token]
        return edumall_access_token.blank?
      end

      def user_logged(cookies)
        if user_logout?(cookies)
          return {}
        end
        edumall_access_token = cookies[:edumall_access_token]
        RestClient.get("#{EDUMALL_SSO_URL}/auth/sso/user.json?oauth_token=#{cookies[:edumall_access_token]}") { |response, request, result, &block|
          case response.code
          when 200
            user_response = JSON.parse(response.body)
            return user_response
          else
            logout(cookies)
            return {}
          end
        }
      end

      def logout(cookies)
        cookies.delete :_provider_sso_session, domain: '.edumall.vn'
        cookies.delete :edumall_access_token, domain: '.edumall.vn'
      end
    end
  end
end
