require 'omniauth-oauth2'
module OmniAuth
  module Strategies
    class Edumall < OmniAuth::Strategies::OAuth2
      # CUSTOM_PROVIDER_URL = 'https://accounts.edumall.vn'
      EDUMALL_SSO_URL = 'https://accounts.edumall.vn'

      option :client_options, {
        :site =>  EDUMALL_SSO_URL,
        :authorize_url => "#{EDUMALL_SSO_URL}/auth/sso/authorize",
        :access_token_url => "#{EDUMALL_SSO_URL}/auth/sso/access_token"
      }

      uid do
        raw_info['id']
      end

      info do
        {
          email: raw_info['email'],
          name: raw_info['name'],
          avatar: raw_info['image'],
          verified: raw_info['verified']
        }
      end

      extra do
        { :raw_info => raw_info}
      end

      def raw_info
        @raw_info ||= access_token.get("/auth/sso/user.json?oauth_token=#{access_token.token}").parsed
      end
    end
  end
end
